/*->c.colour */


#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>



#include "os.h"
#include "transform.h"
#include "xprocess.h"
#include "sprite.h"
#include "bbc.h"
#include "wimp.h"
#include "werr.h"


#include "osglue.h"
#include "oserr.h"
#include "osunits.h"
#include "osgraphics.h"
#include "ossprite.h"
#include "userdraw.h"

#include "deb.h"
#include "etc.h"
#include "wos.h"
#include "sprx.h"
#include "getmatch.h"

#include "colour.h"

/****************************************************************************/
/* Colour */

// these numer 0 to 28 so a lookup table is not really necessary

int winsyscolour[]=
{

 COLOR_SCROLLBAR,						// 18
 COLOR_BACKGROUND,					// 19
 COLOR_ACTIVECAPTION,			// 20
 COLOR_INACTIVECAPTION,	// 21
 COLOR_MENU,												// 22
 COLOR_WINDOW,										// 23
 COLOR_WINDOWFRAME,					// 24
 COLOR_MENUTEXT,									// 25
 COLOR_WINDOWTEXT,							// 26
 COLOR_CAPTIONTEXT,						// 27
 COLOR_ACTIVEBORDER,					// 28
 COLOR_INACTIVEBORDER,			// 29
 COLOR_APPWORKSPACE,					// 30
 COLOR_HIGHLIGHT,								// 31
 COLOR_HIGHLIGHTTEXT,				// 32
 COLOR_BTNFACE,										// 33
 COLOR_BTNSHADOW,								// 34
 COLOR_GRAYTEXT,									// 35
 COLOR_BTNTEXT,										// 36
 COLOR_INACTIVECAPTIONTEXT,	// 37
 COLOR_BTNHIGHLIGHT,								// 38

#if(WINVER >= 0x0400)
 COLOR_3DDKSHADOW,
 COLOR_3DLIGHT,
 COLOR_INFOTEXT,
 COLOR_INFOBK,
#endif /* WINVER >= 0x0400 */

#if(WINVER >= 0x0500)
 COLOR_HOTLIGHT,
 COLOR_GRADIENTACTIVECAPTION,
 COLOR_GRADIENTINACTIVECAPTION,         // value 28
#endif /* WINVER >= 0x0500 */

};


int systempalette[256];

COLORREF currentcolour;



typedef struct modestr
{
 char dx;
 char dy;
 char ln2bpp;
 char mask;

} modestr;



#define MAXMODE 128

static modestr modedata[MAXMODE]=
{
2,4,0,0x01,  // mode 0
4,4,1,0x03,  // mode 1
8,4,2,0x0f,  // mode 2
2,4,1,0x03,  // mode 3
4,4,0,0x01,  // mode 4
8,4,1,0x03,  // mode 5
4,4,1,0x03,  // mode 6
4,4,2,0x0f,  // mode 7
2,4,1,0x03,  // mode 8
4,4,2,0x0f,  // mode 9
8,4,3,0xff,  // mode 10
2,4,1,0x03,  // mode 11
2,4,2,0x0f,  // mode 12
4,4,3,0xff,  // mode 13
2,4,2,0x0f,  // mode 14
2,4,3,0xff,  // mode 15
2,4,2,0x0f,  // mode 16
2,4,2,0x0f,  // mode 17
2,2,0,0x01,  // mode 18
2,2,1,0x03,  // mode 19
2,2,2,0x0f,  // mode 20
2,2,3,0xff,  // mode 21
1,2,2,0x0f,  // mode 22
2,2,0,0x01,  // mode 23
2,4,3,0xff,  // mode 24
2,2,0,0x01,  // mode 25
2,2,1,0x03,  // mode 26
2,2,2,0x0f,  // mode 27
2,2,3,0xff,  // mode 28
2,2,0,0x01,  // mode 29
2,2,1,0x03,  // mode 30
2,2,2,0x0f,  // mode 31
2,2,3,0xff,  // mode 32
2,4,0,0x01,  // mode 33
2,4,1,0x03,  // mode 34
2,4,2,0x0f,  // mode 35
2,4,3,0xff,  // mode 36
2,4,0,0x01,  // mode 37
2,4,1,0x03,  // mode 38
2,4,2,0x0f,  // mode 39
2,4,3,0xff,  // mode 40
2,4,0,0x01,  // mode 41
2,4,1,0x03,  // mode 42
2,4,2,0x0f,  // mode 43
2,4,0,0x01,  // mode 44
2,4,1,0x03,  // mode 45
2,4,2,0x0f,  // mode 46
4,4,3,0xff,  // mode 47
4,2,2,0x0f,  // mode 48
4,2,3,0xff,  // mode 49
1,1,0,0x01,  // mode 50
1,1,0,0x01,  // mode 51
1,1,0,0x01,  // mode 52
1,1,0,0x01,  // mode 53
1,1,0,0x01,  // mode 54
1,1,0,0x01,  // mode 55
1,1,0,0x01,  // mode 56
1,1,0,0x01,  // mode 57
1,1,0,0x01,  // mode 58
1,1,0,0x01,  // mode 59
1,1,0,0x01,  // mode 60
1,1,0,0x01,  // mode 61
1,1,0,0x01,  // mode 62
1,1,0,0x01,  // mode 63
1,1,0,0x01,  // mode 64
1,1,0,0x01,  // mode 65
1,1,0,0x01,  // mode 66
1,1,0,0x01,  // mode 67
1,1,0,0x01,  // mode 68
1,1,0,0x01,  // mode 69
1,1,0,0x01,  // mode 70
1,1,0,0x01,  // mode 71
1,1,0,0x01,  // mode 72
1,1,0,0x01,  // mode 73
1,1,0,0x01,  // mode 74
1,1,0,0x01,  // mode 75
1,1,0,0x01,  // mode 76
1,1,0,0x01,  // mode 77
1,1,0,0x01,  // mode 78
1,1,0,0x01,  // mode 79
1,1,0,0x01,  // mode 80
1,1,0,0x01,  // mode 81
1,1,2,0x0F,  // mode 82
1,1,0,0x01,  // mode 83
1,1,0,0x01,  // mode 84
1,1,0,0x01,  // mode 85
1,1,0,0x01,  // mode 86
1,1,0,0x01,  // mode 87
1,1,0,0x01,  // mode 88
1,1,0,0x01,  // mode 89
1,1,0,0x01,  // mode 90
1,1,0,0x01,  // mode 91
1,1,0,0x01,  // mode 92
1,1,0,0x01,  // mode 93
1,1,0,0x01,  // mode 94
1,1,0,0x01,  // mode 95
1,1,0,0x01,  // mode 96
1,1,0,0x01,  // mode 97
1,1,0,0x01,  // mode 98
1,1,0,0x01,  // mode 99
1,1,0,0x01,  // mode 100
1,1,0,0x01,  // mode 101
1,1,0,0x01,  // mode 102
1,1,0,0x01,  // mode 103
1,1,0,0x01,  // mode 104
1,1,0,0x01,  // mode 105
1,1,0,0x01,  // mode 106
1,1,0,0x01,  // mode 107
1,1,0,0x01,  // mode 108
1,1,0,0x01,  // mode 109
1,1,0,0x01,  // mode 110
1,1,0,0x01,  // mode 111
1,1,0,0x01,  // mode 112
1,1,0,0x01,  // mode 113
1,1,0,0x01,  // mode 114
1,1,0,0x01,  // mode 115
1,1,0,0x01,  // mode 116
1,1,0,0x01,  // mode 117
1,1,0,0x01,  // mode 118
1,1,0,0x01,  // mode 119
1,1,0,0x01,  // mode 120
1,1,0,0x01,  // mode 121
1,1,0,0x01,  // mode 122
1,1,0,0x01,  // mode 123
1,1,0,0x01,  // mode 124
1,1,0,0x01,  // mode 125
1,1,0,0x01,  // mode 126
1,1,0,0x01,  // mode 127

};





os_error * getdeltas(int mode,int * dx,int * dy)
{
 int xdpi;
 int ydpi;
 
 if((mode>>27) & 0x1F)
 {
  xdpi=(mode>>1) & 0x1FFF;
  if(xdpi==0) xdpi=90;
  *dx=180/xdpi;
  ydpi=(mode>>14) & 0x1FFF;
  if(ydpi==0) ydpi=90;
  *dy=180/ydpi;
 }
 else
 {
  mode&=0x7F;
  *dx=modedata[mode].dx;
  *dy=modedata[mode].dy;
 }

 return(NULL);
}


static int bppmap[9]={0,1,2,4,8,16,32,32,24};
static int bitmaskmap[9]={0,0x1,0x3,0xF,0xFF,0x7FFF,0xFFFFFF,0xFFFFFFFF,0xFFFFFF};

os_error * getbpp(int mode,int * bpp,int * bitmask)
{
 int type;

 if((type=(mode & 0xF8000000))!=0)
 {
  type=((type>>27)&0x1F);
  if(bpp) *bpp=bppmap[type];
  if(bitmask) *bitmask=bitmaskmap[type];
 }
 else
 {
  mode&=0x7F;

  if(bpp) *bpp=(1<<modedata[mode].ln2bpp);
  if(bitmask) *bitmask=modedata[mode].mask;
 }

 return(NULL);
}




os_error * getspriteinfo(newsprite_header * sph,int * xdpi,int * ydpi,int * bpp)
{
 int mode;

 if(sph->selector.type.type)  /* it is a new sprite */
 {
  if(xdpi) *xdpi=sph->selector.type.xdpi;
  if(ydpi) *ydpi=sph->selector.type.ydpi;
  if(bpp)  *bpp=bppmap[sph->selector.type.type];
 }
 else
 {
  mode=sph->selector.mode.mode & 0x7F;
  if(xdpi) *xdpi=180/modedata[mode].dx;
  if(ydpi) *ydpi=180/modedata[mode].dy;
  if(bpp)  *bpp=(1<<modedata[mode].ln2bpp);
 }

 return(NULL);
}






os_error * getspritesize(newsprite_header * sph,int * xpix,int * ypix,int * bpp)
{
 int spbpp;
 int mode;
 int bitwidth;
 
 if(sph->selector.type.type)  /* it is a new sprite */
 {
  spbpp=bppmap[sph->selector.type.type];
 }
 else
 {
  mode=sph->selector.mode.mode & 0x7F;
  spbpp=(1<<modedata[mode].ln2bpp);
 }

 bitwidth=32*(sph->width+1)-sph->lbit-(31-sph->rbit);
 if(xpix) *xpix=bitwidth/spbpp;
 if(ypix) *ypix=sph->height+1;
 if(bpp)  *bpp=spbpp;

 return(NULL);
}



#define PRGB(r,g,b) (((r)<<8)|((g)<<16)|((b)<<24))


static int colortable[16]=
{
 PRGB(0xFF,0xFF,0xFF), // WIMPWHITE
 PRGB(0xDD,0xDD,0xDD), // WIMPGREY1
 PRGB(0xBB,0xBB,0xBB), // WIMPGREY2
 PRGB(0x99,0x99,0x99), // WIMPGREY3
 PRGB(0x77,0x77,0x77), // WIMPGREY4
 PRGB(0x55,0x55,0x55), // WIMPGREY5
 PRGB(0x33,0x33,0x33), // WIMPGREY6
 PRGB(0x00,0x00,0x00), // WIMPBLACK 7
 PRGB(0x00,0x44,0x99), // WIMPDBLUE 8
 PRGB(0xee,0xee,0x00), // WIMPYELLOW 9
 PRGB(0x00,0xcc,0x00), // WIMPGREEN 10
 PRGB(0xdd,0x00,0x00), // WIMPRED   11
 PRGB(0xee,0xee,0xbb), // WIMPLYELLOW 12
 PRGB(0x55,0x88,0x00), // WIMPDGREEN 13
 PRGB(0xff,0xbb,0x00), // WIMPORANGE 14
 PRGB(0x00,0xbb,0xff), // WIMPLBLUE 15

};



os_error *wimp_readpalette(wimp_palettestr* p)
{
 int i;

 for(i=0;i<16;i++)
 {
  p->c[i].word=colortable[i];
 }

 p->mouse1.word=colortable[0];
 p->mouse2.word=colortable[1];
 p->mouse3.word=colortable[2];
 p->screenborder.word=colortable[2];

 return(NULL);
}



static const int redweight=299;
static const int greenweight=587;
static const int blueweight=114;


void greyscalepal(int * w,int n)
{
 int sum;
 int r;
 int g;
 int b;
 int grey;

 sum=redweight+greenweight+blueweight;

 while(n--)
 {
  r=((*w)>>8)&0xFF;
  g=((*w)>>16)&0xFF;
  b=((*w)>>24)&0xFF;

  grey=(r*redweight+g*greenweight+b*blueweight)/sum;

  *w++=((grey<<8)|(grey<<16)|(grey<<24));
 }
}



// used for producing greyed out icons

void greyscalequad(int * w,int n)
{
 int sum;
 int r;
 int g;
 int b;
 int grey;

 sum=redweight+greenweight+blueweight;

 while(n--)
 {
  b=((*w))&0xFF;
  g=((*w)>>8)&0xFF;
  r=((*w)>>16)&0xFF;

  grey=(r*redweight+g*greenweight+b*blueweight)/sum;

  grey=127+(128*grey)/255;

  *w++=((grey)|(grey<<8)|(grey<<16));
 }
}





/***************************************************************************/
/* functions for setting colours */



static os_error * newcurrentcolour(COLORREF colour)
{
 os_error * err;

 currentcolour=colour;

          err=graphicscreatesolidbrush2(colour,currenthdcptr);
 if(!err) err=graphicscreatepen2(PS_SOLID,0,colour,currenthdcptr); 

 return(err);
}






/* bits 0..3 = wimp colour (translate for current mode)
        4..6 = gcol action
        7    = foreground/background.
*/


os_error * wimp_setcolour(int colour)
{
 os_error * err;
 int        prevb;

 err=NULL;

 if(colour & 0x80)
 {
  if(((colour>>4) & 0x7)==0x7)
  {
   XSetBkMode(currenthdcptr->hdc,TRANSPARENT,&prevb);
  }
  else
  {
   XSetBkMode(currenthdcptr->hdc,OPAQUE,&prevb);
   SetBkColor(currenthdcptr->hdc,COLREFFROMPAL(cvdu.vdupal.c[colour & 0xF].word));
  }
 }
 else
 {
  if(((colour>>4) & 0x7)==0x3)  SetROP2(currenthdcptr->hdc,R2_XORPEN);
  else                          SetROP2(currenthdcptr->hdc,R2_COPYPEN);
  err=newcurrentcolour(COLREFFROMPAL(cvdu.vdupal.c[colour & 0xF].word));
 }


// SetTextColor(hdc,RGB(0,0,0));
// SetBkColor(hdc,RGB(255,255,255));


 return(err);
}


os_error * wimp_setoscolour(int colour)
{
 return(newcurrentcolour(getoscolour(colour)));
}



os_error * setgcolaction(int pal,int action)
{
 os_error * err;

// SetROP2 has to be here, seems to change colour on NT PS driver

 if(action==3)  SetROP2(currenthdcptr->hdc,R2_XORPEN);
 else           SetROP2(currenthdcptr->hdc,R2_COPYPEN);

 err=newcurrentcolour(COLREFFROMPAL(pal));

 return(err);

}


os_error * setgcolactionreturn(int pal,int action,int * value)
{
 *value=pal;
 return(setgcolaction(pal,action));
}


os_error * setgcol(int pal)
{
 return(setgcolaction(pal,0));
}




os_error * setoppgcol(int pal)
{
 int r;
 int g;
 int b;

 r=(pal>>8)&0xFF;
 g=(pal>>16)&0xFF;
 b=(pal>>24)&0xFF;

 r=0xFF-r;
 g=0xFF-g;
 b=0xFF-b;

 pal=(b<<24)|(g<<16)|(r<<8);

 return(setgcol(pal));
}





int getcolnumber(int pal)
{
 int n;

 if(cvdu.palettesupport) n=cvdu.sizepalette;
 else                    n=cvdu.numcolours;

 return(getmatch(systempalette,systempalette+n-1,pal));
}



int getgcolnumber(int pal)
{
 return(getcolnumber(pal));
}







os_error * seteorcol(int back,int front)
{
 os_error * err;
 int        wcol;

 if(cvdu.bpp<=8)
 {
  if(cvdu.palettesupport)
  {
   physicalpaletteselect(currenthdcptr->hdc);
   wcol=cvdu.wimpcolnos[back] ^ cvdu.wimpcolnos[front];
   err=newcurrentcolour(PALETTEINDEX(wcol));
   idealpaletteselect(currenthdcptr->hdc);
  }
  else
  {
   wcol=cvdu.wimpcolnos[back] ^ cvdu.wimpcolnos[front];
   err=newcurrentcolour(COLREFFROMPAL(systempalette[wcol]));
  }
 }
 else
 {
  wcol=cvdu.vdupal.c[back].word ^ cvdu.vdupal.c[front].word;
  err=newcurrentcolour(COLREFFROMPAL(wcol));
 }

 SetROP2(currenthdcptr->hdc,R2_XORPEN);
 
 return(err);
}



/* in this version back is a real colour */

os_error * seteorcolpal(int back,int front)
{
 os_error * err;
 int        colnum;
 int        wcol;

 if(cvdu.bpp<=8)
 {
  colnum=getcolnumber(back);

  if(cvdu.palettesupport)
  {
   physicalpaletteselect(currenthdcptr->hdc);
   wcol=colnum ^ cvdu.wimpcolnos[front];
   err=newcurrentcolour(PALETTEINDEX(wcol));
   idealpaletteselect(currenthdcptr->hdc);   
  }
  else
  {
   wcol=colnum ^ cvdu.wimpcolnos[front];
   err=newcurrentcolour(COLREFFROMPAL(systempalette[wcol]));
  }
 }
 else
 {
  wcol=back ^ cvdu.vdupal.c[front].word;
  err=newcurrentcolour(COLREFFROMPAL(wcol));
 }

 SetROP2(currenthdcptr->hdc,R2_XORPEN);

 return(err);
}










/*******************************************************************************/



vdustr cvdu;


int hscrlbar=40;
int vscrlbar=40;


vdustr * getcvdu(void)
{
 return(&cvdu);
}



void getcurdeltas(int * dx,int * dy)
{
 int lndeltax=0;
 int lndeltay=0;
 *dx=(1<<lndeltax);
 *dy=(1<<lndeltay);
}










// GetTheColors - returns the count and color values of solid colors
// Returns a pointer to the array containing colors
// hdc - handle to device context


static int colourindex;

static int CALLBACK MyEnumProc(LPVOID lp, LPARAM lpb)
{
 LPLOGPEN lopn;

 lopn = (LPLOGPEN)lp;

 if(lopn->lopnStyle==PS_SOLID) 
 {
  if(colourindex<256)
  {
   ((int*)lpb)[colourindex++]=PALFROMCOLREF(lopn->lopnColor);
  }
 }

 return(1);
}





static os_error * enumeratecolours(HDC hdc,int * pal)
{
 colourindex=0;
 EnumObjects(hdc,OBJ_PEN,MyEnumProc,(LPARAM)pal);

 return(NULL);
}



os_error * getpalette(HDC hdc,int * pal)
{
 int  i;

 if(cvdu.palettesupport)
 {
  GetSystemPaletteEntries(hdc,0,cvdu.sizepalette,(LPPALETTEENTRY)pal);

  for(i=0;i<cvdu.sizepalette;i++)
  {
   pal[i]=PALFROMPALENTRY(pal[i]);
  }

//  cprintf("pal[0] %x pal[255] %x",pal[0],pal[255]);
 }
 else
 {
  enumeratecolours(hdc,pal);
 }

 return(NULL);
}







/* how palettes work

(1) we have an ideal palette, the colours we'd like to be present
    this we keep realised when we're allowed to
    create on start up, lose on closedown

(2) we have another palette which lets us select any colour by its
    physical colour number
    create on start up, lose on closedown

(3) we have a copy of the physical palette


*/




static HPALETTE idealpal;
static HPALETTE physicalpal;


static os_error * createphysicalpalette(int nc)
{
 LOGPALETTE    * plp ;
 int             i;

 plp =(LOGPALETTE*)malloc(sizeof(LOGPALETTE)+(nc-1)*sizeof(PALETTEENTRY));

 plp->palVersion=0x0300;
 plp->palNumEntries=(unsigned short)nc;

 for(i=0;i<nc;i++)
 {
  plp->palPalEntry[i].peRed   =(char)i;
  plp->palPalEntry[i].peGreen =0;
  plp->palPalEntry[i].peBlue  =0;
  plp->palPalEntry[i].peFlags =PC_EXPLICIT ;
 }
          
 physicalpal=CreatePalette(plp) ;
 free (plp) ;          

 return(NULL);
}



static os_error * createidealpalette(vdustr * cvdu)
{
 LOGPALETTE    * plp ;
 int             i;
 int             ncolours;
 int             pal[256];
 int             npal;
 int             match;
 int             nentries;

// vdu->numcolours get 10*2 from this

 nentries=cvdu->sizepalette;

 plp=(LOGPALETTE*)malloc(sizeof(LOGPALETTE)+(nentries-1)*sizeof(PALETTEENTRY));

 plp->palVersion=0x0300;
 plp->palNumEntries=(unsigned short)nentries;

 if(nentries<256)
 {
  for(i=0;i<16;i++)
  {
   plp->palPalEntry[i].peRed   =(char)((systempalette[i]>>8)&0xFF);
   plp->palPalEntry[i].peGreen =(char)((systempalette[i]>>16)&0xFF);
   plp->palPalEntry[i].peBlue  =(char)((systempalette[i]>>24)&0xFF);
   plp->palPalEntry[i].peFlags =0;
  }
 }
 else
 {
  genpalbpp(pal,8,&ncolours);

  npal=ncolours;
  for(i=0;i<10;i++)
  {
   match=getmatch(pal,pal+(npal-1),systempalette[i]);
   // colour in palette closest to system colour
   pal[match]=pal[npal-1];
   npal--;
  }

  for(i=nentries-1;i>=(nentries-10);i--)
  {
   match=getmatch(pal,pal+(npal-1),systempalette[i]);
   // colour in palette closest to system colour
   pal[match]=pal[npal-1];
   npal--;
  }

//  cprintf("create ideal npal %d nentries %d",npal,nentries);

 // 0 to 9

  for(i=0;i<10;i++)
  {
   plp->palPalEntry[i].peRed   =(char)((systempalette[i]>>8)&0xFF);
   plp->palPalEntry[i].peGreen =(char)((systempalette[i]>>16)&0xFF);
   plp->palPalEntry[i].peBlue  =(char)((systempalette[i]>>24)&0xFF);
   plp->palPalEntry[i].peFlags =0;
  }

 // 10 to 245

  for(i=0;i<npal;i++)
  {
   plp->palPalEntry[i+10].peRed   =(char)((pal[i]>>8)&0xFF);
   plp->palPalEntry[i+10].peGreen =(char)((pal[i]>>16)&0xFF);
   plp->palPalEntry[i+10].peBlue  =(char)((pal[i]>>24)&0xFF);
   plp->palPalEntry[i+10].peFlags =PC_NOCOLLAPSE;
  }
          
 // 246 to 255

  for(i=npal+10;i<nentries;i++)
  {
   plp->palPalEntry[i].peRed   =(char)((systempalette[i]>>8)&0xFF);
   plp->palPalEntry[i].peGreen =(char)((systempalette[i]>>16)&0xFF);
   plp->palPalEntry[i].peBlue  =(char)((systempalette[i]>>24)&0xFF);
   plp->palPalEntry[i].peFlags =0;
  }
 }

 idealpal=CreatePalette(plp) ;

 free (plp) ;          

 return(NULL);
}



void setwimpcolnos(void)
{
 int i;
 int n;

 if(cvdu.bpp<=8)
 {
  if(cvdu.palettesupport) n=cvdu.sizepalette;
  else                    n=cvdu.numcolours;

  for(i=0;i<16;i++)
  {
   cvdu.wimpcolnos[i]=getmatch(systempalette,systempalette+n-1,cvdu.vdupal.c[i].word);
  }
 }
}


// program close down

static os_error * palettefinit(void)
{
 if(physicalpal) DeleteObject(physicalpal);
 if(idealpal)    DeleteObject(idealpal);

 return(NULL);
}



static os_error * paletteinit(HDC hdc)
{

 palettefinit();

 if(cvdu.bpp<=8)
 {
  getpalette(hdc,systempalette);
  setwimpcolnos();
  
  if(cvdu.palettesupport)
  {
   createphysicalpalette(cvdu.sizepalette);
   createidealpalette(&cvdu);
  }
 }

 return(NULL);
}



// OS asks what palette we want

os_error * palettequery(HWND hwnd,int * code)
{
 HDC      hdc;
 int      n;

// cprintf("pal query");

 if(cvdu.bpp<=8)
 {
  hdc=GetDC(hwnd);
  SelectPalette(hdc,idealpal,FALSE);
  XRealizePalette(hdc,&n);
  getpalette(hdc,systempalette);
  setwimpcolnos();
  ReleaseDC(hwnd,hdc);
  *code=1;
 }
 return(NULL);
}


// OS tells us the palette has been changed by source window

os_error * palettechanged(HWND src,HWND hwnd,int * code)
{
 HDC hdc;

 if(cvdu.bpp<=8 && src!=hwnd)
 {
  hdc=GetDC(src);
  getpalette(hdc,systempalette);
  ReleaseDC(src,hdc);
  setwimpcolnos();
  vdupalvars();
 }

 return(NULL);
 USE(code);
}



// OS tells us system colours have changed

os_error * syscolourchange(HWND hwnd)
{
 HDC hdc;

 if(cvdu.bpp<=8)
 {
  hdc=GetDC(hwnd);
  getpalette(hdc,systempalette);
  ReleaseDC(hwnd,hdc);
  setwimpcolnos();
 }

 return(NULL);
 USE(hwnd);
}



os_error * idealpaletteselect(HDC hdc)
{
 int n;

 if(cvdu.bpp<=8)
 {
  if(cvdu.palettesupport)
  {
   SelectPalette(hdc,idealpal,FALSE);
   XRealizePalette(hdc,&n);   // caches realize state see UnrealizeObject()
  }
 }

 return(NULL);
}



os_error * physicalpaletteselect(HDC hdc)
{

 if(cvdu.bpp<=8)
 {
  if(cvdu.palettesupport)
  {
   SelectPalette(hdc,physicalpal,FALSE);
  }
 }

 return(NULL);
}







void vdupalvars2(vdustr * vdu)
{
 wimp_readpalette(&vdu->vdupal);
}


void vdumodevars1(HDC hdc,vdustr * vdu)
{
 int  xpic;
 int  ypic;


 vdu->xpix=xpic=GetSystemMetrics(SM_CXSCREEN); // screen size in pixels
 vdu->ypix=ypic=GetSystemMetrics(SM_CYSCREEN); // screen size in pixels

 vdu->xdpi=GetDeviceCaps(hdc,LOGPIXELSX);
 vdu->ydpi=GetDeviceCaps(hdc,LOGPIXELSY);
 vdu->bpp=vdu->tbpp=GetDeviceCaps(hdc,BITSPIXEL);

 if(vdu->bpp==15) vdu->bpp=16;
 else
 if(vdu->bpp==24) vdu->bpp=32;     // this is obviously creating an incorrect result

 vdu->ln2bpp=ln2bpptab[vdu->bpp];
 vdu->sizepalette=GetDeviceCaps(hdc,SIZEPALETTE);
 vdu->reservedcolours=GetDeviceCaps(hdc,NUMRESERVED);
 vdu->numcolours=GetDeviceCaps(hdc,NUMCOLORS);
 vdu->caps=GetDeviceCaps(hdc,RASTERCAPS);
 vdu->palettesupport=((vdu->caps & RC_PALETTE)!=0);

 if(vdu->palettesupport) vdu->ncolours=vdu->sizepalette;
 else                    vdu->ncolours=vdu->numcolours;

 cprintf("xdpi=%d ydpi=%d bpp=%d nc=%d ln2=%d",vdu->xdpi,vdu->ydpi,vdu->bpp,vdu->ncolours,vdu->ln2bpp);
 cprintf("rastercaps %d numcol %d",vdu->caps & RC_PALETTE,GetDeviceCaps(hdc,NUMCOLORS));

 vdu->lndeltax=0;
 vdu->lndeltay=0;
 vdu->deltax=(1<<(vdu->lndeltax));
 vdu->deltay=(1<<(vdu->lndeltay));

 vdu->maskx=0xFFFFFFFF-(vdu->deltax-1);
 vdu->masky=0xFFFFFFFF-(vdu->deltay-1);

 vdu->extrax=xpix2os(1)+1;
 vdu->extray=ypix2os(1)+1;

 vdu->screenx=xpix2os(vdu->xpix);
 vdu->screeny=ypix2os(vdu->ypix);

 vdu->gcharsizex=8;
 vdu->gcharsizey=8;
 vdu->gcharspacex=8;
 vdu->gcharspacey=8;

 vdu->mode=1+(vdu->xdpi<<1)+(vdu->ydpi<<14)+((vdu->ln2bpp+1)<<27);


 vdupalvars2(vdu);

 hscrlbar=ypix2os(GetSystemMetrics(SM_CYHSCROLL));
 vscrlbar=xpix2os(GetSystemMetrics(SM_CXVSCROLL));
}



void vdumodevars2(vdustr * cvdu)
{
 HDC hdc;

 hdc=CreateIC(TEXT("DISPLAY"),NULL,NULL,NULL); // DeleteDC below

 vdumodevars1(hdc,cvdu);
 paletteinit(hdc);

 DeleteDC(hdc);
}



void vdumodevars(void)
{
 vdumodevars2(&cvdu);
}



void vdupalvars(void)
{
 vdupalvars2(&cvdu);
}


void vdumodefinit(void)
{
 palettefinit();
}


os_error * vduenterprintmode(hdcstr * hdcptr)
{

 vdumodevars1(hdcptr->hdc,&cvdu);

 return(NULL);
}


os_error * vduexitprintmode(void)
{

 vdumodevars2(&cvdu);

 return(NULL);
}


