/*->c.fsx */

#include <stdafx.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>

#include "shlwapi.h"

#include "os.h"
#include "flex.h"
#include "oserr.h"
#include "wimp.h"
#include "wos.h"
#include "poll.h"

#include "err.h"
#include "bits.h"

#include "deb.h"
#include "etc.h"

#include "fsx.h"
#include "alloc.h"

#include "filetype.h"

#include "timex.h"
#include "ostime.h"
#include "osreg.h"
#include "osshell.h"
#include "xstdio.h"


static int fs_expandlinks=1;


// look for <key> in src and expand it

os_error * fs_expandpath(TCHAR * src,TCHAR * dest,int size)
{
 os_error * err;
 TCHAR    * s;
 TCHAR    * d;
 TCHAR    * q;
 int        n;

 err=NULL;

 s=src;
 d=dest;
 while(*s)
 {
		if(*s==TEXT('"'))				// strip quotes, filename can't contain quotes so junk the lot?
		{														// plan B would be to strip leading/trailing
			s++;
		}
  else
  if(*s==TEXT('<'))
  {
   if(*(s+1)==TEXT('<'))
   {
    *d++=*s;
    s+=2;
   }
   else
   {
    q=s+1; // points at start of key
    while(*q)
    {
     if(*q==TEXT('>'))
     {
      XMEMCPYX(d,s+1,q-(s+1));
      *(d+(q-(s+1)))=0;
      n=size-(d-dest);

      if(*d==TEXT('%'))
      {
       err=osreadvar(d,d,n);
       n=strlen(d)+1;
      }
      else
      {
       err=regreadstr(d,d,&n);
      }

//						cprintf("d %s",d);

      if(!err && n)
      {
       s+=q-s+1;
       d+=n-1;
       break;
      }
      err=NULL;
     }
     q++;
    }

    if(*q==0)
    {
     *d++=*s++;
    }
   }
  }
  else
  {
   *d++=*s++;
  }
 }
 *d=0;

//cprintf("dest=%s",dest);

	if(fs_expandlinks && fs_extensionis(dest,TEXT("lnk"))==0)
	{
		TCHAR temp[MAX_PATH];

  osshellshortcuttarget(dest,temp,sizeof(temp)/sizeof(TCHAR));
		if(*temp)
		{
//		cprintf("expand %s %s",dest,temp);

		 xzstrncpy(dest,temp,size);
		}
	}

 return(err);
}



os_error * fs_eof(fshandle fh,int * eof)
{
 os_error * err;
 int        size;
 int        posn;

 err=XGetFileSize((HANDLE)fh,NULL,(DWORD*)&size);
 if(!err && size!=-1)
 {
  err=fs_tell(fh,&posn);
  *eof=(posn>=size);
 }

 return(err);
}



os_error * fs_tell(fshandle fh,int * posn)
{
 os_error * err;
 DWORD      result;

 err=XSetFilePointer((HANDLE)fh,0,NULL,FILE_CURRENT,&result);
 if(!err) *posn=(int)result;

 return(err);
}



os_error * fs_open(TCHAR * name,int mode,fshandle * fh)
{
 os_error * err;
 DWORD      createmode;
 DWORD      accessmode;
 HANDLE     handle;
 int        type;
 TCHAR      xname[MAX_PATH];

 err=fs_expandpath(name,xname,sizeof(xname)/sizeof(TCHAR));

//	cprintf("fs_open1 err=%x",err);

 if(mode=='r')
 {
  createmode=OPEN_EXISTING;
  accessmode=GENERIC_READ;
 }
 else
 if(mode=='u')
 {
  createmode=OPEN_ALWAYS;
  accessmode=GENERIC_READ|GENERIC_WRITE;
 }
 else
 {
  accessmode=GENERIC_READ|GENERIC_WRITE;
  fs_exists2(xname,&type);
  if(type==1) createmode=TRUNCATE_EXISTING;
  else
  if(type==0) createmode=CREATE_NEW;
  else
  {
   // error
   createmode=CREATE_NEW;
  }
 }


 err=XCreateFile(xname,accessmode,FILE_SHARE_READ,NULL,createmode,FILE_ATTRIBUTE_NORMAL,NULL,&handle);

//	cprintf("fs_open2 err=%x",err);

 if(err) *fh=0;
 else    *fh=(fshandle)handle;

 return(err);
}



os_error * fs_close(fshandle fh,os_error * ep)
{
 os_error * err;

 err=XCloseHandle((HANDLE)fh);

 if(!ep) return(err);
 else    return(ep);
}




os_error * fs_readat(fshandle fh,void * b,int n,int at)
{
 os_error * err;

 err=NULL;

 if(n)
 {
           err=fs_seek(fh,at);
  if(!err) err=fs_read(fh,b,n);
 }

 return(err);
}



os_error * fs_readn(fshandle fh,void * b,int n,int * read)
{
 os_error * err;


 err=XReadFile((HANDLE)fh,b,n,(unsigned long*)read,NULL);

 return(err);
}



os_error * fs_read(fshandle fh,void * b,int n)
{
 os_error      * err;
 unsigned long   read;

 err=NULL;

 while(n>0)
 {
  err=XReadFile((HANDLE)fh,b,n,&read,NULL);
  if(!err && read==0)
  {
   err=geterror(ERD);
   break;
  }
  n-=read;
  b=((char*)b)+read;
 }

 return(err);
}




os_error * fs_getc(fshandle fh,int * c)
{
 os_error * err;
 int        eof;

 err=fs_eof(fh,&eof);
 if(!err)
 {
  if(eof) *c=-1;
  else
  {
   *c=0;
   err=fs_read(fh,c,1);
  }
 }

 return(err);
}



os_error * fs_writen(fshandle fh,void * b,int n,int * write)
{
 return(XWriteFile((HANDLE)fh,b,n,(unsigned long*)write,NULL));
}




os_error * fs_write(fshandle fh,void * b,int n)
{
 os_error      * err;
 unsigned long   written;

 err=NULL;

 while(n)
 {
  err=XWriteFile((HANDLE)fh,b,n,&written,NULL);
  if(err) break;
  n-=written;
  b=(((char*)b)+written);

  if(!err && !written)
  {
   err=geterror(EWR);
   break;
  }
 }
 return(err);
}






os_error * fs_writeat(fshandle fh,void * b,int n,int at)
{
 os_error * err;

 err=NULL;

 if(n)
 {
  err=fs_seek(fh,at);
  if(!err) err=fs_write(fh,b,n);
 }

 return(err);
}



os_error * fs_seek(fshandle fh,int posn)
{
 DWORD result;
 return(XSetFilePointer((HANDLE)fh,posn,NULL,FILE_BEGIN,&result));
}


os_error * fs_setfileextent(fshandle fh,int ex)
{
 os_error * err;

          err=fs_seek(fh,ex);
 if(!err) err=XSetEndOfFile((HANDLE)fh);
 
 return(err);
}




os_error * fs_saveblock(TCHAR *name,int type,void * start,int len)
{
 os_error * err;
 fshandle   fh;

 err=fs_open(name,'w',&fh);
 if(!err)
 {
  err=fs_write(fh,start,len);
  err=fs_close(fh,err);
 }
 
 return(err);
 USE(type);
}



os_error * fs_loadblock(TCHAR *name,void * start)
{
 os_error * err;
 fstat      fs;
 fshandle   fh;

 err=fs_stat(name,&fs);
 if(!err && fs.object==1)
 {
  err=fs_open(name,'r',&fh);
  if(!err)
  {
   err=fs_read(fh,start,fs.length);
   err=fs_close(fh,err);
  }
 }

 return(err);
}



os_error * fs_alloc(TCHAR * name,unsigned char ** alloc,unsigned int * length)
{
 os_error * err;
 fstat      fs;
 fshandle   fh;

 *alloc=NULL;
 *length=0;

 err=fs_stat(name,&fs);
 if(!err && fs.object==1)
 {
  err=salloc((flex_ptr)alloc,fs.length);
  if(!err)
  {
//			cprintf("alloced %d",fs.length);

   err=fs_open(name,'r',&fh);
   if(!err)
   {
    err=fs_read(fh,*alloc,fs.length);
//					cprintf("read data");
    err=fs_close(fh,err);
   }
   if(!err)
   {
    *length=fs.length;
   }
   else
   {
    sfree((flex_ptr)alloc);
   }
  }
 }

 return(err);
}





os_error * fs_delete(TCHAR * name)
{
 os_error * err;
 fstat      fs;
 TCHAR      xname[MAX_PATH];

 err=fs_expandpath(name,xname,sizeof(xname)/sizeof(TCHAR));
 if(!err)
 {
  err=fs_stat2(xname,&fs);
  if(!err)
  {
   if(fs.object==1 || fs.object==0) err=XDeleteFile(xname);
   else
   if(fs.object==2)
   {
    err=XRemoveDirectory(xname);
   }
  }
 }

 return(err);
}



os_error * fs_rename(TCHAR * old,TCHAR * newname)
{
 os_error * err;
 TCHAR      xold[MAX_PATH];
 TCHAR      xnewname[MAX_PATH];

          err=fs_expandpath(old,xold,sizeof(xold)/sizeof(TCHAR));
 if(!err) err=fs_expandpath(newname,xnewname,sizeof(xnewname)/sizeof(TCHAR));
 if(!err) err=XMoveFile(xold,xnewname);

 return(err);
}



int fs_filetype(int load)
{
 if((load & 0xFFF00000)==0xFFF00000)
           return((load >> 8) & 0xFFF);
 else return(CODE);
}



static HANDLE findhandle;

void fs_startscan(void)
{
 if(findhandle) cprintf("!!!!!! find handle overwrite !!!!!");
 findhandle=NULL;
}


void fs_savescan(fsscanhandle * save)
{
 *save=(fsscanhandle)findhandle;
}


void fs_loadscan(fsscanhandle save)
{
 if(findhandle) cprintf("!!!!!! find handle overwrite in loadscan !!!!!");
 findhandle=(HANDLE)save;
}


os_error * fs_endscan(void)
{
 os_error * err;

 err=NULL;

 if(findhandle)
 {
  err=XFindClose(findhandle);
  findhandle=NULL;
 }

 return(err);
}





os_error * fs_nextitem(TCHAR * dirname,fxstat * f,TCHAR * wild,int * eof)
{
 os_error       * err;
 TCHAR            buff[MAX_PATH];
 WIN32_FIND_DATA  fdata;
 arctime          t;

 err=NULL;

 *eof=1;

// cprintf("dir %s wild %s",dirname,wild);

 while(1)
 {
  if(findhandle==NULL)
  {
//   strcpy(buff,dirname);
   fs_expandpath(dirname,buff,sizeof(buff)/sizeof(TCHAR));
   if(wild && strlen(wild))
   {
    fs_strcat(buff,NITEM(buff),wild);
   } 
//   cprintf("findfirst %s",buff);
   err=XFindFirstFile(buff,&fdata,&findhandle);
   if(err)
   { 
    findhandle=NULL;
    break;
   }
//   cprintf("return %s",fdata.cFileName);
  }
  else
  {
//   cprintf("findnext %x",(int)findhandle);
   err=XFindNextFile(findhandle,&fdata,eof);
   if(err || (*eof))
   {
//    cprintf("eof=%d err=%d",eof,(int)err);
    XFindClose(findhandle);
    findhandle=NULL;
    break;
   }
  }


  if(findhandle)
  {
//   cprintf("name %s attr %d",fdata.cFileName,fdata.dwFileAttributes);
   if(ustrcmp(fdata.cFileName,TEXT(".")) && ustrcmp(fdata.cFileName,TEXT("..")))
   {
    osfiletime2riscostime(&t,&fdata.ftLastWriteTime);

    xzstrncpy(f->name,fs_leaf(fdata.cFileName),sizeof(f->name)/sizeof(TCHAR));
    f->f.type=fs_filetypefromextension(f->name);
    f->f.load=f->f.type<<8;
    setfiletime(&f->f,&t);

    f->f.length=fdata.nFileSizeLow;
    f->f.acc   =fdata.dwFileAttributes;
    f->f.object=(fdata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)?2:1;
    
//    cprintf("fname %s",f->name);

    *eof=0;
    break;
   }
  }
  else
  {
   break;
  }
 }

 return(err);
}





// return true for hidden files

int fs_hidden(int acc)
{
 return(acc & FILE_ATTRIBUTE_HIDDEN);
}


int fs_system(int acc)
{
 return(acc & FILE_ATTRIBUTE_SYSTEM);
}


int fs_readonly(int acc)
{                
 return(acc & FILE_ATTRIBUTE_READONLY);
}



os_error * fs_stat2(TCHAR * name,fstat * f)
{
 os_error                  * err;
 WIN32_FIND_DATA             fdata;
 arctime                     t;
 HANDLE                      findhandle;
 

 err=XFindFirstFile(name,&fdata,&findhandle);

// cprintf("stat2 handle %x name %s",findhandle,name);


 if(!err) XFindClose(findhandle);

//err=XGetFileAttributesEx(name,GetFileExInfoStandard,&fdata);
// won't work on '95

 if(!err)
 {
  osfiletime2riscostime(&t,&fdata.ftLastWriteTime);
  f->type=fs_filetypefromextension(name);
  f->load  =f->type<<8;
  setfiletime(f,&t);
  f->length=fdata.nFileSizeLow;
  f->acc   =fdata.dwFileAttributes;
  f->object=(fdata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)?2:1;
 }
 else
 {
//  cprintf("fs_stat err");
  err=NULL;
  f->object=0;
 }

 return(err);
}


os_error * fs_stat(TCHAR * name,fstat * f)
{
 os_error * err;
 TCHAR      xname[MAX_PATH];

 err=fs_expandpath(name,xname,sizeof(xname)/sizeof(TCHAR));
 if(!err) err=fs_stat2(xname,f);

 return(err);
}


int fs_timecmp(fstat * f0,fstat * f1,int res)
{
 _int64 t0;
 _int64 t1;
 _int64 difftime;

 t0=(((_int64)(f0->load & 0xFF))<<32)|(((_int64)f0->exec) & 0xFFFFFFFF);
 t1=(((_int64)(f1->load & 0xFF))<<32)|(((_int64)f1->exec) & 0xFFFFFFFF);
 difftime=t0-t1;


 if(difftime<(_int64)(-res)) return(-1);
 else
 if(difftime>(_int64)(res)) return(1);

 return(0);
}


#ifdef NEVER

os_error * fs_newest(char * name[],int object,char ** newest,fstat * f)
{
 os_error * err;
 char       xname[MAX_PATH];
 fstat      f0;
 fstat      f1;

          err=fs_expandpath(name[0],xname,sizeof(xname)/sizeof(TCHAR));
 if(!err) err=fs_stat2(xname,&f0);
 if(!err) err=fs_expandpath(name[1],xname,sizeof(xname)/sizeof(TCHAR));
 if(!err) err=fs_stat2(xname,&f1);

 if(!err)
 {
  if(f0.object==object && f1.object!=object)
  {
   *newest=name[0];
   *f=f0;
  }
  else
  if(f0.object!=object && f1.object==object)
  {
   *newest=name[1];
   *f=f1;
  }
  else
  if(f0.object!=object && f1.object!=object)
  {
   *newest=NULL;
  }
  else
  {
   if(fs_timecmp(&f0,&f1)>=0)
   {
    *newest=name[0];
    *f=f0;
   }
   else
   {
    *newest=name[1];
    *f=f1;
   }
  }
 }

 return(err);
}


#endif


// if name[1] exists return details else return results for name[0]

os_error * fs_pair(TCHAR * name0,TCHAR * name1,int object,TCHAR ** newest,fstat * f)
{
 os_error * err;
 TCHAR      xname[MAX_PATH];
 fstat      f0;
 fstat      f1;

 err=NULL;

 f0.object=f1.object=0;

 if(name0)
 {
           err=fs_expandpath(name0,xname,sizeof(xname)/sizeof(TCHAR));
  if(!err) err=fs_stat2(xname,&f0);
 }

 if(name1)
 {
  if(!err) err=fs_expandpath(name1,xname,sizeof(xname)/sizeof(TCHAR));
  if(!err) err=fs_stat2(xname,&f1);
 }


 if(!err)
 {
  if(f1.object==object)
  {
   *newest=name1;
   *f=f1;
  }
		else
  if(f0.object==object)
  {
   *newest=name0;
   *f=f0;
  }
  else
  {
   *newest=NULL;
  }
 }

 return(err);
}





os_error * fs_stamp(TCHAR * name,fstat * f)
{
 os_error * err;
 FILETIME   LastWriteTime;
 arctime    t;
 HANDLE     hFile;

 err=XCreateFile(name,GENERIC_WRITE,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL,&hFile);
 if(!err && hFile)
 {
  filetime(f,&t);
  riscostime2osfiletime(&LastWriteTime,&t);
  SetFileTime(hFile,NULL,NULL,&LastWriteTime);
  err=XCloseHandle(hFile);
 }

 return(NULL);
}


/* returns 0 ==does not exist  1==file 2==dir */

os_error * fs_exists2(TCHAR * name,int * type)
{
 os_error   * err;
 DWORD        acc;

	if(name)
	{
  err=XGetFileAttributes(name,&acc);

//	if(err) cprintf("fs_exists2 err %s",err->errmess);

  if(err)
  {
   *type=0;
   err=NULL;
  }
  else
  {
   *type=(acc & FILE_ATTRIBUTE_DIRECTORY)?2:1;
  }
	}
	else
	{
		err=NULL;
		*type=0;
	}

 return(err);
}


os_error * fs_exists(TCHAR * name,int * type)
{
 os_error * err;
 TCHAR      xname[MAX_PATH];

	if(name)
	{
           err=fs_expandpath(name,xname,sizeof(xname)/sizeof(TCHAR));
  if(!err) err=fs_exists2(xname,type);
	}
	else
	{
		*type=0;
		err=NULL;
	}

 return(err);
}



os_error * fs_create(TCHAR * name,int length,int type)
{
 os_error * err;
 HANDLE     handle;
 TCHAR      xname[MAX_PATH];

          err=fs_expandpath(name,xname,sizeof(xname)/sizeof(TCHAR));
 if(!err) err=XCreateFile(xname,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL,&handle);

 return(err);
 
 USE(type);
 USE(length);
}



os_error * fs_cdir(TCHAR * name)
{
 os_error * err;
 TCHAR      xname[MAX_PATH];
 fstat      f;

 err=fs_expandpath(name,xname,sizeof(xname)/sizeof(TCHAR));
 if(!err)
 {
  fs_stat2(xname,&f);
  if(f.object==0) err=XCreateDirectory(xname,NULL);
 }

 return(err);
}






os_error * fs_canonicalpath(TCHAR * path,TCHAR * buffer,int len,
                                     TCHAR * pathvar,TCHAR * pathstring)
{
 char * p;

// strcpy(buffer,path);

 GetFullPathName(path,len,buffer,&p);
 return(NULL);

 USE(pathstring);
 USE(pathvar);
}



os_error * fs_isrelativepath(TCHAR * path,int * relative)
{

 *relative=PathIsRelative(path);

 return(NULL);
}


os_error * fs_combinepath(TCHAR * newpath,TCHAR * dirpath,TCHAR * filepath)
{

 PathCombine(newpath,dirpath,filepath);

 return(NULL);
}


TCHAR * fs_typestring(int type)
{
 char * p;
 getdescriptionptr(type,&p);
 if(p) return(p);
 else  return(TEXT(""));
}




os_error * fs_strcat(TCHAR * path,int maxlen,TCHAR * filename)
{
	os_error * err;
 char     * p;

	err=NULL;

 p=path+ustrlen(path);
 if(p>path && *(p-1)==TEXT('\\'))
 {

 }
 else
 {
		if(p<(path+maxlen-1))
		{
   *p++=TEXT('\\');
		}
		else
		{
			err=geterrorf(EMAXSTRING,TEXT("fs_strcat"));
		}
 }

 if(!err) err=xzstrncpyu(p,filename,maxlen-(p-path));

 return(err);
}



os_error * fs_join(TCHAR * buffer,int maxlen,TCHAR * path,TCHAR * filename)
{
	os_error * err;

          err=xzstrncpyu(buffer,path,maxlen);
	if(!err) err=fs_strcat(buffer,maxlen,filename);

	return(err);
}


// PathFindFileName(LPCTSTR pPath);


TCHAR * fs_leaf(TCHAR * filename)
{
 TCHAR * p;

        p=strrchr(filename,'\\');
 if(!p) p=strrchr(filename,'/');
 if(!p)
 {
  p=strrchr(filename,':');
  if(!p) p=filename;
  else   p+=1;
 } else  p+=1;
 return(p);
}


os_error * fs_path(TCHAR * filename,TCHAR * path,int maxlen)
{
	os_error * err;
 TCHAR    * p;

	err=NULL;

 p=fs_leaf(filename);
 if(p && p>filename)
 {
  err=xzstrncpyu(path,filename,MIN(p-filename,maxlen));
 }
 else
 {
  *path=0;
 }

	return(err);
}



int fs_extensionis(TCHAR * name,TCHAR * ext)
{
 TCHAR * p;
 
 p=PathFindExtension(name);
	if(!*p) return(1);
	else				return(cstrcmp(ext,p+1));

/*
 p=strrchr(name,'.');
 if(!p) return(1);
 else   return(cstrcmp(ext,p+1));
*/
}



void fs_checkextension(TCHAR * name,TCHAR * ext)
{
 char * p;

 p=PathFindExtension(name);
 if(!*p)
 {
  strcat(name,".");
  strcat(name,ext);
 }
 else
 {
  if(cstrcmp(p+1,ext)) strcpy(p+1,ext);
 }


/*
 p=strrchr(name,'.');
 if(!p)
 {
  strcat(name,".");
  strcat(name,ext);
 }
 else
 {
  if(cstrcmp(p+1,ext)) strcpy(p+1,ext);
 }
*/

}


// return pointer to extension or NULL

TCHAR * fs_extension(TCHAR * name)
{
 TCHAR * p;

 p=PathFindExtension(name);
 if(!*p) return(NULL);
 else    return(p+1);

/* 
 p=strrchr(name,'.');
 if(!p) return(p);
 else   return(p+1);
*/
}


TCHAR * fs_newextension(TCHAR * name,TCHAR * ext)
{
 TCHAR * p;


 p=PathFindExtension(name);
 if(!(*p))
 {
//  p=name+ustrlen(name)+1;
  *p=TEXT('.');
 }

 ustrcpy(p+1,ext);

 return(name);

/* 
 p=strrchr(name,'.');
 if(!p)
 {
  p=name+strlen(p)+1;
  *p='.';
 }

 strcpy(p+1,ext);

 return(name);
*/
}



TCHAR * fs_addtoname(TCHAR * name,TCHAR * extra)
{
 int    len;
 TCHAR * p;


 p=PathFindExtension(name);
 if(*p)
 {
  len=ustrlen(extra);
  memmove(p+len,p,(strlen(p)+1)*sizeof(TCHAR));
  XMEMCPYX(p,extra,len);
 }
 else
 {
  ustrcat(name,extra);
 }

 return(name);

/*
 p=strrchr(name,'.');
 if(p)
 {
  len=strlen(extra);
  memmove(p+len,p,strlen(p)+1);
  XMEMCPYX(p,extra,len);
 }
 else
 {
  strcat(name,extra);
 }

 return(name);
*/
}



int fs_filetypefromextension(TCHAR * name)
{
 TCHAR * p;
 TCHAR * q;
 int     type;

 type=0xFFD;

 p=PathFindExtension(name);
 if(*p)
 {
  p++;
  getfiletype(&type,p);
 }
 else
 {
		q=PathFindFileName(name);
  p=strrchr(name,TEXT(','));
  if(p && p>q)
  {
   p++;
   getfiletype(&type,p);
		}
 }

 return(type);



/*
	 
 p=strrchr(name,'.');
 if(p)
 {
  p++;
  getfiletype(&type,p);
 }
 else
 {
  p=strrchr(name,',');
  if(p)
  {
   p++;
   getfiletype(&type,p);
		}
		else
		{
   type=0xFFD;
		}
 }

 return(type);

*/
}



// return -1 unless we actually find the filename extension

int fs_filetypefromextensionx(TCHAR * name)
{
 TCHAR * p;
 TCHAR * q;
 int     type;

	type=-1;

 p=PathFindExtension(name);
 if(*p)
 {
  p++;
  getfiletypex(&type,NULL,p);
 }
 else
 {
		q=PathFindFileName(name);
  p=strrchr(name,TEXT(','));
  if(p && p>q)
  {
   p++;
   getfiletypex(&type,NULL,p);
		}
 }

 return(type);
}



os_error * fs_settype(TCHAR * filename,int type)
{
 USE(type);
 USE(filename);
 return(NULL);
}



// ANSI only

FILE * fopenex(const char *filename, const char *mode)
{
 char xname[MAX_PATH];

 fs_expandpath((char*)filename,xname,sizeof(xname));

 return(fopen(xname,mode));
}
