/*->c.task */


#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"
#include "wimp.h"
#include "flex.h"
#include "wimpt.h"

#include "fsx.h"
#include "err.h"
#include "wos.h"
#include "trans.h"
#include "alloc.h"
#include "poll.h"
#include "timex.h"
#include "deb.h"
#include "temp.h"
#include "sp.h"
#include "appinfo.h"
#include "mlo.h"
#include "colour.h"
#include "hourglass.h"
#include "oscb.h"
#include "etc.h"

#include "oserr.h"

#include "task.h"





static errtag errortable[31]=
{
 ETASK ,"Not enough memory, or not within *desktop world.",
 EMEM  ,"{EME}",
 ERD   ,"{ERD}",
 EWR   ,"{EWR}",
 EMEMF ,"Memory is corrupt!",
 EINT  ,"{EINT}",
 ETEMP ,"{ETEMP}",
 ENOTF ,"{ENOTF}",
 ESVDG ,"{ESVDG}",
 ENOWS ,"{ENOWS}",
 EUXDS ,"{EUXDS}",
 EUXRF ,"{EUXRF}",
 EMEMAF,"{EMEMAF}",
 EMEMBF,"{EMEMBF}",
 EMEMAD,"{EMEMAD}",
 EMEMFE,"{EMEMFE}",
 EMEMCH,"{EMEMCH}",
 EMEMBAD,"{EMEMBAD}",
 ENOTOKVAL,"{ENOTOKVAL}",
 ENOEVENT,"{ENOEVENT}",
 ETEMPX,"{ETEMPX}",
 ETEMPF,"{ETEMPF}",
 EREPORTED,"{EREP}",
 ESAVECANCELLED,"{ESCAN}",
 ELOADCANCELLED,"{ELCAN}",
 EBADREG,"{EBADREG}",
 ENOTFOUND,"{ENOTFOUND}",
	ENOPRINTER,"{ENOPRINTER}",
	EMAXSTRING,"{EMAXSTRING}",
	EUNKNOWNFILETYPE,"{EUNKFT}",
 ELAST ,""
};


static errlink errorlink;


os_error * taskerrors(void)
{
 return(adderrortable(errortable,&errorlink));
}





int wimpversion;  




os_error * finittask(void)
{
 vdumodefinit();
 finittemp();
 menulofinit();
 return(flex_finit());
}





int resexists(char * path,char * leaf)
{
 os_error  *   err;
 TCHAR         name[MAX_PATH];
 fstat         f;

 fs_join(name,NITEM(name),path,leaf);

 err=fs_stat(name,&f);
 return(!err && f.object);
}



os_error * inittask(char * name,char * textname,char * spritename,
                    char * resources,char * apps,taskinitfn initfn)
{
 os_error * err;

#ifdef NEVER
 char       temp[64];
 char     * p;
#endif


 wimpversion=wimpt_init2(name,textname,spritename);      /* boots task */
 vdumodevars();

          err=starttask();        /* does checks and retrieves task handle */
 
 cprintf("start task err=%x",err);
 if(!err) err=flex_init();
 cprintf("flex_init2 err=%x",err);
 if(!err) err=initerror();
 cprintf("initerror err=%x",err);
 if(!err) err=inittemp();
 cprintf("inittemp err=%x",err);
 if(!err) err=initsprites();
 if(!err) err=inittrans();
 cprintf("inittrans err=%x",err);
 if(!err && initfn) err=initfn(0);
 if(!err) err=initalloc();
 cprintf("initalloc err=%x",err);
 if(!err) err=pollinit();
 timexinitsys(NULL,NULL);
 if(!err) err=hourglassinit();

 if(!err) err=taskerrors();
 cprintf("taskerrors err=%x",err);
 if(!err) err=addspritesx(resources,"Sprites.spr");
 cprintf("addsprites err=%x",err);

 if(!err)
 {
//  if(ospresent(RISCOS310)<0) err=addspritesx(resources,"Sprites2.spr");
 }

 if(!err) err=event(EVENT_LOADSPRITES,NULL,0);

 if(!err) err=event(EVENT_SUBRESOURCES,NULL,0);

 if(!err) err=addtranstable(resources,"Messages.txt");
 cprintf("add messages err=%x",err);
 if(!err) err=event(EVENT_LOADMESSAGES,NULL,0);
 if(!err) err=infowindowinit();

 cprintf("end inittask err=%x",err);

 return(err);
}


static int taskisrunning;

void runtask(void)
{
 taskisrunning=1;
 event(EVENT_TASKRUN,NULL,0);
 while(1) poll();
}


int taskrunning(void)
{
 return(taskisrunning);
}


